Package com.saxonica.ee.stream.adjunct

## Class FeedToEventBuffer

- java.lang.Object
- - net.sf.saxon.event.Outputter
  - - net.sf.saxon.event.ProxyOutputter
    - - com.saxonica.ee.stream.feed.ItemFeed
      - - com.saxonica.ee.stream.adjunct.FeedToEventBuffer

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class FeedToEventBuffer
      extends ItemFeed

  An ItemFeed that captures all written events in a buffer for subsequent replay.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.Outputter

      `pipelineConfiguration, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FeedToEventBuffer​(Outputter next, ItemFeed agglomerator, XPathContext context)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `append​(Item item)` | Supply one item towards the streamed input of the expression
    `void` | `attribute​(NodeName name, SimpleType type, java.lang.CharSequence value, Location location, int properties)` | Notify an attribute.
    `void` | `characters​(java.lang.CharSequence chars, Location location, int properties)` | Notify character data.
    `void` | `close()` | Finish evaluating the expression.
    `void` | `comment​(java.lang.CharSequence content, Location location, int properties)` | Notify a comment.
    `void` | `endDocument()` | Notify the end of a document node
    `void` | `endElement()` | Notify the end of an element.
    `void` | `namespace​(java.lang.String prefix, java.lang.String uri, int properties)` | Notify a namespace binding.
    `void` | `processingInstruction​(java.lang.String name, java.lang.CharSequence data, Location location, int properties)` | Output a processing instruction
    `void` | `replay​(Outputter out)` | Replay the captured events to a supplied destination
    `void` | `setBuffer​(java.util.List<OutputterEvent> buffer)` |
    `void` | `setHasFailed()` | Mark this feed as having failed (that is, as having detected and reported a dynamic error).
    `void` | `startContent()` | Notify the start of the content, that is, the completion of all attributes and namespaces.
    `void` | `startDocument​(int properties)` | Notify the start of a document node
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element, supplying all attributes and namespaces
    `void` | `startElement​(NodeName elemName, SchemaType typeCode, Location location, int properties)` | Notify the start of an element

    - ### Methods inherited from class com.saxonica.ee.stream.feed.ItemFeed

      `append, dynamicError, endSelectedParentNode, getContext, getExpression, getResult, getTerminator, hasFailed, open, processItems, setExpression, setTerminator, startSelectedParentNode`

    - ### Methods inherited from class net.sf.saxon.event.ProxyOutputter

      `getNextOutputter, open, setLocation, setUnparsedEntity, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.Outputter

      `getConfiguration, getPipelineConfiguration, getStringReceiver, getSystemId, namespaces, setPipelineConfiguration, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `handlesAppend`

- - ### Constructor Detail

    - #### FeedToEventBuffer

          public FeedToEventBuffer​(Outputter next,
                                   ItemFeed agglomerator,
                                   XPathContext context)

  - ### Method Detail

    - #### setBuffer

          public void setBuffer​(java.util.List<OutputterEvent> buffer)

    - #### startDocument

          public void startDocument​(int properties)
                             throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the start of a document node
      Specified by:
        `startDocument` in interface `Receiver`
      Overrides:
        `startDocument` in class `ProxyOutputter`
      Parameters:
        `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the end of a document node
      Specified by:
        `endDocument` in interface `Receiver`
      Overrides:
        `endDocument` in class `ProxyOutputter`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType typeCode,
                                   Location location,
                                   int properties)

      Description copied from class: `ProxyOutputter`
      Notify the start of an element
      Overrides:
        `startElement` in class `ProxyOutputter`
      Parameters:
        `elemName` - the name of the element.
        `typeCode` - the type annotation of the element.
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the start of an element, supplying all attributes and namespaces
      Specified by:
        `startElement` in interface `Receiver`
      Overrides:
        `startElement` in class `ProxyOutputter`
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### attribute

          public void attribute​(NodeName name,
                                SimpleType type,
                                java.lang.CharSequence value,
                                Location location,
                                int properties)

      Description copied from class: `ProxyOutputter`
      Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.
      Overrides:
        `attribute` in class `ProxyOutputter`
      Parameters:
        `name` - The name of the attribute
        `type` - The type annotation of the attribute
        `value` - the string value of the attribute
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this attribute
        NO_SPECIAL_CHARACTERS
          Attribute value contains no special characters

    - #### namespace

          public void namespace​(java.lang.String prefix,
                                java.lang.String uri,
                                int properties)

      Description copied from class: `ProxyOutputter`
      Notify a namespace binding. This method is called at some point after startElement(). The semantics are similar to the xsl:namespace instruction in XSLT, or the namespace node constructor in XQuery. A namespace must not conflict with any namespaces already used for element or attribute names.
      Overrides:
        `namespace` in class `ProxyOutputter`
      Parameters:
        `prefix` - The namespace prefix; zero-length string for the default namespace
        `uri` - The namespace URI. In some cases a zero-length string may be used to indicate a namespace undeclaration.
        `properties` - The REJECT_DUPLICATES property: if set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:

    - #### startContent

          public void startContent()

      Description copied from class: `ProxyOutputter`
      Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial Outputter of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.
      Overrides:
        `startContent` in class `ProxyOutputter`

    - #### endElement

          public void endElement()
                          throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the end of an element. The Outputter must maintain a stack if it needs to know which element is ending.
      Specified by:
        `endElement` in interface `Receiver`
      Overrides:
        `endElement` in class `ProxyOutputter`
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public void characters​(java.lang.CharSequence chars,
                                 Location location,
                                 int properties)

      Description copied from class: `ProxyOutputter`
      Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.
      Specified by:
        `characters` in interface `Receiver`
      Overrides:
        `characters` in class `ProxyOutputter`
      Parameters:
        `chars` - The characters
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section

    - #### processingInstruction

          public void processingInstruction​(java.lang.String name,
                                            java.lang.CharSequence data,
                                            Location location,
                                            int properties)

      Description copied from class: `ProxyOutputter`
      Output a processing instruction
      Specified by:
        `processingInstruction` in interface `Receiver`
      Overrides:
        `processingInstruction` in class `ProxyOutputter`
      Parameters:
        `name` - The PI name. This must be a legal name (it will not be checked).
        `data` - The data portion of the processing instruction
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.

    - #### comment

          public void comment​(java.lang.CharSequence content,
                              Location location,
                              int properties)

      Description copied from class: `ProxyOutputter`
      Notify a comment. Comments are only notified if they are outside the DTD.
      Specified by:
        `comment` in interface `Receiver`
      Overrides:
        `comment` in class `ProxyOutputter`
      Parameters:
        `content` - The content of the comment
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.

    - #### append

          public void append​(Item item)
                      throws XPathException

      Supply one item towards the streamed input of the expression
      Specified by:
        `append` in interface `Receiver`
      Specified by:
        `append` in class `ItemFeed`
      Parameters:
        `item` - the item to be supplied
      Throws:
        `XPathException` - if the operation fails

    - #### close

          public void close()
                     throws XPathException

      Description copied from class: `ItemFeed`
      Finish evaluating the expression.
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `ItemFeed`
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### replay

          public void replay​(Outputter out)
                      throws XPathException

      Replay the captured events to a supplied destination
      Parameters:
        `out` - the destination `Receiver` to receive the events
      Throws:
        `XPathException` - if any error occurs

    - #### setHasFailed

          public void setHasFailed()

      Mark this feed as having failed (that is, as having detected and reported a dynamic error). Once the feed is marked as having failed, it should not attempt to process any further input.
      Overrides:
        `setHasFailed` in class `ItemFeed`